debian: initial packaging

This commit is contained in:
Frédéric Péters 2016-05-04 16:03:22 +02:00
parent 6bc22b0dfe
commit a8e8484f39
17 changed files with 459 additions and 0 deletions

5
debian/changelog vendored Normal file
View File

@ -0,0 +1,5 @@
chrono (0-0) unstable; urgency=low
* Initial release
-- Frederic Peters <fpeters@entrouvert.com> Wed, 04 May 2016 16:03:34 +0200

26
debian/chrono-manage vendored Executable file
View File

@ -0,0 +1,26 @@
#!/bin/sh
NAME=chrono
MANAGE=/usr/lib/$NAME/manage.py
# load Debian default configuration
export WELCO_SETTINGS_FILE=/usr/lib/$NAME/debian_config.py
# check user
if test x$1 = x"--forceuser"
then
shift
elif test $(id -un) != "$NAME"
then
echo "error: must use $0 with user ${NAME}"
exit 1
fi
if test $# -eq 0
then
python ${MANAGE} help
exit 1
fi
python ${MANAGE} "$@"

5
debian/chrono.dirs vendored Normal file
View File

@ -0,0 +1,5 @@
/etc/chrono
/usr/lib/chrono
/var/lib/chrono/collectstatic
/var/lib/chrono/tenants
/var/log/chrono

3
debian/chrono.docs vendored Normal file
View File

@ -0,0 +1,3 @@
COPYING
README
debian/nginx-example.conf

195
debian/chrono.init vendored Normal file
View File

@ -0,0 +1,195 @@
#!/bin/sh
### BEGIN INIT INFO
# Provides: chrono
# Required-Start: $network $local_fs $remote_fs $syslog
# Required-Stop: $network $local_fs $remote_fs $syslog
# Should-start: postgresql
# Should-stop: postgresql
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Portal Management System
# Description: Portal Management System
### END INIT INFO
# Author: Entr'ouvert <info@entrouvert.com>
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Multichannel request processing"
NAME=chrono
DAEMON=/usr/bin/gunicorn
RUN_DIR=/run/$NAME
PIDFILE=$RUN_DIR/$NAME.pid
LOG_DIR=/var/log/$NAME
SCRIPTNAME=/etc/init.d/$NAME
BIND=unix:$RUN_DIR/$NAME.sock
WORKERS=5
TIMEOUT=30
WELCO_SETTINGS_FILE=/usr/lib/$NAME/debian_config.py
MANAGE_SCRIPT="/usr/bin/$NAME-manage"
USER=$NAME
GROUP=$NAME
# Exit if the package is not installed
[ -x $MANAGE_SCRIPT ] || exit 0
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
DAEMON_ARGS=${DAEMON_ARGS:-"--pid $PIDFILE \
--user $USER --group $GROUP \
--daemon \
--access-logfile $LOG_DIR/gunicorn-access.log \
--log-file $LOG_DIR/gunicorn-error.log \
--bind=$BIND \
--workers=$WORKERS \
--worker-class=sync \
--timeout=$TIMEOUT \
--name $NAME \
$NAME.wsgi:application"}
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions
# Create /run directory
if [ ! -d $RUN_DIR ]; then
install -d -m 755 -o $USER -g $GROUP $RUN_DIR
fi
# environment for wsgi
export WELCO_SETTINGS_FILE
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --exec $DAEMON -- \
$DAEMON_ARGS \
|| return 2
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name `basename $DAEMON`
return 0
}
do_migrate() {
log_action_msg "Applying migrations (migrate_schemas).."
su $USER -s /bin/sh -p -c "$MANAGE_SCRIPT migrate_schemas"
log_action_msg "done"
}
do_collectstatic() {
log_action_msg "Collect static files (collectstatic).."
su $USER -s /bin/sh -p -c "$MANAGE_SCRIPT collectstatic --noinput"
log_action_msg "done"
}
case "$1" in
start)
log_daemon_msg "Starting $DESC " "$NAME"
do_migrate
do_collectstatic
do_start
case "$?" in
0|1) log_end_msg 0 ;;
2) log_end_msg 1 ;;
esac
;;
stop)
log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) log_end_msg 0 ;;
2) log_end_msg 1 ;;
esac
;;
status)
status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
;;
reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
log_daemon_msg "Reloading $DESC" "$NAME"
do_collectstatic
do_migrate
do_reload
log_end_msg $?
;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_migrate
do_collectstatic
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
echo "Usage: $SCRIPTNAME {start|stop|status|restart|reload|force-reload}" >&2
exit 3
;;
esac

3
debian/chrono.install vendored Normal file
View File

@ -0,0 +1,3 @@
debian/chrono-manage /usr/bin
debian/settings.py /etc/chrono
debian/debian_config.py /usr/lib/chrono

49
debian/chrono.postinst vendored Normal file
View File

@ -0,0 +1,49 @@
#! /bin/sh
set -e
NAME="chrono"
USER=$NAME
GROUP=$NAME
CONFIG_DIR="/etc/$NAME"
MANAGE_SCRIPT="/usr/bin/$NAME-manage"
case "$1" in
configure)
# make sure the administrative user exists
if ! getent passwd $USER >/dev/null; then
adduser --disabled-password --quiet --system \
--no-create-home --home /var/lib/$NAME \
--gecos "$NAME user" --group $USER
fi
# ensure dirs ownership
chown $USER:$GROUP /var/log/$NAME
chown $USER:$GROUP /var/lib/$NAME/collectstatic
chown $USER:$GROUP /var/lib/$NAME/tenants
# create a secret file
SECRET_FILE=$CONFIG_DIR/secret
if [ ! -f $SECRET_FILE ]; then
echo -n "Generating Django secret..." >&2
cat /dev/urandom | tr -dc [:alnum:]-_\!\%\^:\; | head -c70 > $SECRET_FILE
chown root:$GROUP $SECRET_FILE
chmod 0440 $SECRET_FILE
fi
;;
triggered)
su -s /bin/sh -c "$MANAGE_SCRIPT hobo_deploy --redeploy" $USER
;;
abort-upgrade|abort-remove|abort-deconfigure)
;;
*)
echo "postinst called with unknown argument \`$1'" >&2
exit 1
;;
esac
#DEBHELPER#
exit 0

1
debian/chrono.triggers vendored Normal file
View File

@ -0,0 +1 @@
interest-noawait hobo-redeploy

1
debian/compat vendored Normal file
View File

@ -0,0 +1 @@
7

27
debian/control vendored Normal file
View File

@ -0,0 +1,27 @@
Source: chrono
Maintainer: Frederic Peters <fpters@entrouvert.com>
Section: python
Priority: optional
Build-Depends: python-setuptools (>= 0.6b3), python-all (>= 2.6.6-3), python-django, debhelper (>= 7)
Standards-Version: 3.9.6
X-Python-Version: >= 2.7
Package: python-chrono
Architecture: all
Depends: ${misc:Depends}, ${python:Depends},
python-django (>= 1.8),
python-gadjo
Recommends: python-django-mellon
Description: Agendas System (Python module)
Package: chrono
Architecture: all
Depends: ${misc:Depends},
python-chrono (= ${binary:Version}),
python-hobo,
python-django-tenant-schemas,
python-psycopg2,
python-django-mellon,
gunicorn
Recommends: nginx, postgresql
Description: Agendas System

18
debian/debian_config.py vendored Normal file
View File

@ -0,0 +1,18 @@
# This file is sourced by "execfile" from chrono.settings
import os
PROJECT_NAME = 'chrono'
# SAML2 authentication
INSTALLED_APPS += ('mellon',)
#
# hobotization (multitenant)
#
execfile('/usr/lib/hobo/debian_config_common.py')
#
# local settings
#
execfile(os.path.join(ETC_DIR, 'settings.py'))

58
debian/nginx-example.conf vendored Normal file
View File

@ -0,0 +1,58 @@
server {
listen 443;
server_name *-chrono.example.org;
ssl on;
ssl_certificate /etc/ssl/certs/ssl-cert-snakeoil.pem;
ssl_certificate_key /etc/ssl/private/ssl-cert-snakeoil.key;
access_log /var/log/nginx/chrono.example.org-access.log combined;
error_log /var/log/nginx/chrono.example.org-error.log;
location ~ ^/static/(.+)$ {
root /;
try_files /var/lib/chrono/tenants/$host/static/$1
/var/lib/chrono/collectstatic/$1
=404;
}
location ~ ^/media/(.+)$ {
alias /var/lib/chrono/tenants/$host/media/$1;
}
location / {
proxy_pass http://unix:/var/run/chrono/chrono.sock;
proxy_set_header Host $http_host;
proxy_set_header X-Forwarded-SSL on;
proxy_set_header X-Forwarded-Protocol ssl;
proxy_set_header X-Forwarded-Proto https;
proxy_set_header X-Real-IP $remote_addr;
proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
}
}
server {
listen 80;
server_name *-chrono.example.org;
access_log /var/log/nginx/chrono.example.org-access.log combined;
error_log /var/log/nginx/chrono.example.org-error.log;
location ~ ^/static/(.+)$ {
root /;
try_files /var/lib/chrono/tenants/$host/static/$1
/var/lib/chrono/collectstatic/$1
=404;
}
location ~ ^/media/(.+)$ {
alias /var/lib/chrono/tenants/$host/media/$1;
}
location / {
proxy_pass http://unix:/var/run/chrono/chrono.sock;
proxy_set_header Host $http_host;
proxy_set_header X-Real-IP $remote_addr;
proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
}
}

1
debian/python-chrono.dirs vendored Normal file
View File

@ -0,0 +1 @@
/usr/lib/chrono

2
debian/python-chrono.docs vendored Normal file
View File

@ -0,0 +1,2 @@
COPYING
README

2
debian/python-chrono.install vendored Normal file
View File

@ -0,0 +1,2 @@
usr/bin/manage.py /usr/lib/chrono
usr/lib/python2*/*-packages

8
debian/rules vendored Executable file
View File

@ -0,0 +1,8 @@
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
%:
dh $@ --with python2

55
debian/settings.py vendored Normal file
View File

@ -0,0 +1,55 @@
# Configuration for chrono.
# You can override Welco default settings here
# Welco is a Django application: for the full list of settings and their
# values, see https://docs.djangoproject.com/en/1.7/ref/settings/
# For more information on settings see
# https://docs.djangoproject.com/en/1.7/topics/settings/
# WARNING! Quick-start development settings unsuitable for production!
# See https://docs.djangoproject.com/en/1.7/howto/deployment/checklist/
# This file is sourced by "execfile" from /usr/lib/chrono/debian_config.py
# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = False
TEMPLATE_DEBUG = False
#ADMINS = (
# # ('User 1', 'watchdog@example.net'),
# # ('User 2', 'janitor@example.net'),
#)
# ALLOWED_HOSTS must be correct in production!
# See https://docs.djangoproject.com/en/dev/ref/settings/#allowed-hosts
ALLOWED_HOSTS = [
'*',
]
# Databases
# Default: a local database named "chrono"
# https://docs.djangoproject.com/en/1.7/ref/settings/#databases
# Warning: don't change ENGINE
# DATABASES['default']['NAME'] = 'chrono'
# DATABASES['default']['USER'] = 'chrono'
# DATABASES['default']['PASSWORD'] = '******'
# DATABASES['default']['HOST'] = 'localhost'
# DATABASES['default']['PORT'] = '5432'
LANGUAGE_CODE = 'fr-fr'
TIME_ZONE = 'Europe/Paris'
# Email configuration
# EMAIL_SUBJECT_PREFIX = '[chrono] '
# SERVER_EMAIL = 'root@chrono.example.org'
# DEFAULT_FROM_EMAIL = 'webmaster@chrono.example.org'
# SMTP configuration
# EMAIL_HOST = 'localhost'
# EMAIL_HOST_USER = ''
# EMAIL_HOST_PASSWORD = ''
# EMAIL_PORT = 25
# HTTPS Security
# CSRF_COOKIE_SECURE = True
# SESSION_COOKIE_SECURE = True